
#include "src/all.h"



void FX::reset()
{
	frameShake = 0;

	for(int i = 0;i<MAX_PARTICLE;i++)
		particleId[i] = -1;
}

FX::FX()
{
	frameShake = 0;
	positionX = new float[MAX_PARTICLE];
	positionY = new float[MAX_PARTICLE];
	speedX = new float[MAX_PARTICLE];
	speedY = new float[MAX_PARTICLE];
	particleId = new int[MAX_PARTICLE];
	for(int i = 0;i<MAX_PARTICLE;i++)
		particleId[i] = -1;
}
void FX::draw(int cameraX,int cameraY)
{
	if(FX::frameShake>0)
	{
    int dx = (rand()%9)-4;
    int dy = (rand()%9)-4;
		ML_horizontal_scroll(dx);
		ML_vertical_scroll(dy);
	}
	for(int i = 0;i<MAX_PARTICLE;i++)
	{
		int x = positionX[i]-cameraX+64;
		int y = positionY[i]-cameraY+32;
		int id = particleId[i];
		switch(id)
		{
			case P_WALL:
				ML_rectangle(x,y,x+2,y+2,1,ML_WHITE,ML_BLACK);
			break;
			case P_STALACTITE:
				ML_rectangle(x,y,x+2,y+2,1,ML_WHITE,ML_BLACK);
			break;
			case P_BURNING:
				ML_rectangle(x,y,x+2,y+2,0,ML_WHITE,ML_WHITE);
			break;
			case P_DEATH:
				ML_rectangle(x,y,x+1,y+1,0,ML_WHITE,ML_WHITE);
			break;
		}
	}

}

void FX::frame()
{
	FX::frameShake--;

	for(int i = 0;i<MAX_PARTICLE;i++)
	{
		if(particleId[i] != -1 && particleId[i] != P_BURNING)
		{
			positionX[i] += speedX[i];
			positionY[i] += speedY[i];
			if(positionX[i]<-64 || positionX[i]>720 || positionY[i]<-64 || positionY[i]>70*8)
				particleId[i] = -1;
			speedX[i] *=0.92;
			speedY[i] +=0.07;
		}
		else if(particleId[i] == P_BURNING)
		{
			positionX[i] += speedX[i];
			positionY[i] += speedY[i];
			if(speedY[i]<-0.2)
				particleId[i] = -1;
			if((rand()%100)<30)speedX[i] = -0.1;
			else if((rand()%70)<30)speedX[i] = 0.1;
			speedY[i] -=0.001;
		}
	}
}

void FX::shake()
{
	frameShake = 30;
}

void FX::addParticle(int x,int y, float speedTX, float speedTY, int type)
{
	for(int i = 0;i<MAX_PARTICLE;i++)
	{
		if(particleId[i] == -1)
		{
			positionX[i] = x;
			positionY[i] = y;
			speedX[i] = speedTX;
			speedY[i] = speedTY;
			particleId[i] = type;
			return;
		}
	}
}
