#include "src/all.h"
#include <math.h>

void Element::start(int xt,int yt,int idt)
{
	x = xt;
	y = yt;
	id = idt;
	frameCount = 0;
	broken = 0;
	activated = 0;
	switch(id)
	{
		case E_STALACTITE :
			falling = 0;
		break;
		case E_VINE:case E_TREE:
			burning = false;
		break;

		case E_ENEMY:
			frozen = false;
			y-=0.5;
			int a = (rand()%100);
			for(int i = 0;i<a;i++)frame(1);
		break;
	}
}

void Element::frame(int quick)
{
	if(id == -1)return;
	frameCount++;

	int hx;
	int hy;
	int distSquare;

	if(!quick)
	{
		hx = Single::getHeros()->getX();
		hy = Single::getHeros()->getY();

		distSquare = abs(hx-x)+abs(hy-y);
	}
	else distSquare = 999;

	if(id == E_TREE)
	{
		int distSquare2 = abs(hx-x+32)+abs(hy-y);
		if(distSquare2 < distSquare)distSquare = distSquare2;
	}


	switch(id)
	{
		case E_STALACTITE :
			if(falling == 0)
			{
				int hx = Single::getHeros()->getX();
				if(hx+16>x && hx<x+16)
					falling = 1;
			}
			if(falling == 1)
				y+=2;
			if(Single::getMap()->getTilePoint(x+4,y+8) != -1 && falling != 2)
			{
				falling = 2;

				for(int i = 0;i<3;i++)
					Single::getFX()->addParticle(x+4,y+8,((float)((rand()%20)-10))/5,-((float)((rand()%5)))/5,P_STALACTITE);
				Single::getMap()->setTilePoint(x,y,99);
			}

			if(distSquare<50 && falling == 1)
			{
				if(hx+8>x && hx<x+8 && hy+8>y && hy<y+8)
						Single::getGame()->die(D_STALACTITE);
			}

		break;
		case E_ENEMY:
			if(!frozen)
				y-=sin(((float)frameCount)/20.0)/2;
			if(distSquare<50)
			{
				if(hx+6>x && hx<x+6 && hy+6>y && hy<y+6 && !frozen)
						Single::getGame()->die(D_CIRCLE);

				if(Single::getHeros()->pointInRay(x+4,y+4) && !frozen)
				{
					frozen = true;
					x -= x%8;
					y = (int)y;
					y += 8-(((int)y)%8);
					//y += 8;
					Single::getMap()->setTilePoint(x,y,99);
				}
			}
		break;

		case E_STORE:
			if(distSquare < 15){
				if(IsKeyDown(KEY_CHAR_SQUARE))
				{
					Single::getGame()->startDialog(0);
				}
			}
		break;

		case E_PRESS:
			if(distSquare < 7){
				if(IsKeyDown(KEY_CHAR_SQUARE))
				{
					activated = true;
					Single::getGame()->die(D_PRESS);
				}
			}
		break;
		case E_BORING_GUY:
			if(distSquare < 15){
				if(IsKeyDown(KEY_CHAR_SQUARE))
				{
					Single::getGame()->startDialog(1);
				}
			}
		break;

		case E_WIN :
			if(distSquare <= 16)
				Single::getGame()->win();
		break;

		case E_VINE :

		if(distSquare <= 13){
			if(Single::getHeros()->hasUpgrade(U_TORCH))burning = 1;
		}
		if(distSquare <= 8 && !burning){
			Single::getGame()->die(D_POISON);
		}
		if(burning)
		{
			burning++;
			if((rand()%100)<=20)
				Single::getFX()->addParticle(x+rand()%8,y+4+rand()%4,((float)((rand()%20)-10)/10),-0.02-((float)(rand()%100))/1000,P_BURNING);

		}
		break;


		case E_TREE:
			if(distSquare <= 20 && burning == 0){
				if(Single::getHeros()->hasUpgrade(U_TORCH))burning = 1;
			}
			if(burning)
			{
				if(distSquare<=15 && burning >  20)Single::getGame()->die(D_FIRE);
				burning++;
				for(int a = 0;a<4;a++)
				Single::getFX()->addParticle(x-rand()%40+8,y+4+rand()%4,((float)((rand()%20)-10)/10),-0.02-((float)(rand()%100))/1000,P_BURNING);

			}
		break;


		case E_BOMB :
			if(frameCount == 100)
			{

				Single::getFX()->shake();
				Element* elements = Single::getElements();
				for(int i = 0;i<MAX_ELEMENT;i++)
				{
					elements[i].bombExplodingAt(x,y);
				}
				Heros* heros = Single::getHeros();
				if(heros->getX()<x+12 && heros->getX()>x-12 && heros->getY()>y-12 && heros->getY()<y+12)
					Single::getGame()->die(D_EXPLOSION);

			}

		break;


		case E_LASER :
			if(hx>x && hx-248<x)
			{
				if(hy>y-6+8 && hy<y-2+8)
				{
					Single::getGame()->die(D_LASER);
				}
			}
		break;
	}
}

int Element::isAvailable()
{
	return id==-1;
}
void Element::bombExplodingAt(int bombX,int bombY)
{
	if(id == -1)return;

	if(id == E_WALL && !broken)
	{
		if(x<bombX+12 && x>bombX-12 && y<bombY+12 && y>bombY-12)
		{
			Single::getMap()->setTilePoint(x,y,-1);
			broken = true;
			for(int i = 0;i<4;i++)
				Single::getFX()->addParticle(x+4,y+4,((float)((rand()%20)-10))/5,-((float)((rand()%5)))/5,P_WALL);

		}
	}
}
int Element::shouldDelete()
{
	return (id == E_BOMB && frameCount>500) || (id == E_VINE && burning>100) || (id == E_TREE && burning>400);
}
void Element::draw(int cameraX,int cameraY)
{
	if(id == -1)return;
	unsigned char test[8] = {155,94,94,94,94,94,94,155};

	const unsigned char sprite0[]={0x80, 0xbe, 0xa2, 0xbe, 0x80, 0xf7, 0xf7, 0xf7, };
	const unsigned char sprite1[]={0x0, 0x7e, 0x5a, 0x7e, 0x5a, 0x66, 0x7e, 0x0, };
	const unsigned char sprite2[]={0x0, 0x7e, 0x5a, 0x7e, 0x66, 0x5a, 0x7e, 0x0, };
	const unsigned char sprite3[]={0xe7, 0x99, 0xbd, 0x7e, 0x7e, 0xbd, 0x99, 0xe7, };
	const unsigned char sprite4[]={0x0, 0x7e, 0x7e, 0xa5, 0xa5, 0xdb, 0xdb, 0xff, };
	const unsigned char sprite5[]={0x0, 0x7e, 0x78, 0x76, 0x76, 0x78, 0x7e, 0x0, };
	const unsigned char sprite6[]={0xff, 0xff, 0xff, 0x0, 0x0, 0xff, 0xff, 0xff, };
	const unsigned char sprite7[]={0x0, 0x18, 0x3c, 0x7e, 0x7e, 0x3c, 0x18, 0x0, };
	const unsigned char sprite8[]={0xff, 0xf3, 0xef, 0xc7, 0xbb, 0xbb, 0xbb, 0xc7, };
	const unsigned char sprite9[]={0xe3, 0xc9, 0x19, 0x7e, 0x3d, 0xbc, 0x81, 0x4b, };
	const unsigned char sprite10[]={0x7f, 0xbf, 0xdf, 0xef, 0xf7, 0x81, 0x7e, 0x0, };
	const unsigned char sprite11[]={0xfe, 0xfd, 0xfb, 0xf7, 0xef, 0x81, 0x7e, 0x0, };
	const unsigned char sprite12[]={0x7e, 0x7e, 0x99, 0xdb, 0x18, 0x7e, 0x0, 0xff, };
	const unsigned char sprite13[]={0x0, 0x5a, 0x0, 0x6c, 0x6c, 0xa, 0x62, 0x0, };
	const unsigned char sprite14[]={0x3c, 0x38, 0x38, 0x83, 0xc3, 0x93, 0x33, 0x73, };
	const unsigned char sprite15[]={0xc3, 0x81, 0x0, 0x0, 0x0, 0x0, 0x81, 0xc3, };
	const unsigned char sprite16[]={0xc3, 0x81, 0x0, 0x0, 0x0, 0x0, 0x81, 0xc3, };
	const unsigned char sprite17[]={0x81, 0x81, 0x81, 0xc3, 0xe7, 0xe7, 0xe7, 0xc3, };
	const unsigned char sprite18[]={0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xbd, 0x0, };
	const unsigned char sprite19[]={0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xbd, 0x0, };
	const unsigned char sprite20[]={0x7e, 0x7e, 0x99, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, };
	const unsigned char sprite21[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char sprite22[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char sprite23[]={0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0x18, 0x7e, 0x0, };

	int hx = Single::getHeros()->getX();
	int hy = Single::getHeros()->getY();

	int distSquare = abs(hx-x)+abs(hy-y);

	switch(id)
	{

		case E_SIGN_ACID:case E_SIGN_FALLING:
			ML_bmp_8_and_cl(sprite0,-(cameraX)+x+64,-(cameraY)+y+32);
			if(distSquare < 20){
				if(id  == E_SIGN_ACID)
				{
					PrintStr(40,1,"shift : jump");
					PrintStr(40,8,"alpha : bomb");
					PrintStr(30,15,"optn : freeze gun");
				}
				else
				{
					ML_rectangle(20,0,108,14,0,ML_BLACK,ML_BLACK);
					PrintStr(23,1,"Falling stuff, don't");
					PrintStr(21,8,"forget your hard hat !");
				}
			}
		break;
		case E_STORE:
			ML_bmp_8_and_cl(sprite1,-(cameraX)+x+64,-(cameraY)+y+32);
			if(distSquare < 15){
				PrintStr(34,1,"x2 : open store");
			}
		break;
		case E_BORING_GUY:
			ML_bmp_8_and_cl(sprite2,-(cameraX)+x+64,-(cameraY)+y+32);
			if(distSquare < 15){
				ML_rectangle(33,0,100,7,0,ML_BLACK,ML_BLACK);
				PrintStr(34,1,"x2 : talk");
			}
		break;
		case E_STALACTITE:
			ML_bmp_8_and_cl(sprite4,-(cameraX)+x+64,-(cameraY)+y+32);
		break;
		case E_LASER:
			ML_bmp_8_and_cl(sprite5,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
			ML_rectangle(-(cameraX)+x+64+8,-(cameraY)+y+32+3,-(cameraX)+x+64+8+248,-(cameraY)+y+32+4,0,ML_WHITE,ML_WHITE);
		break;
		case E_WALL:
			if(!broken)
				ML_bmp_8_and_cl(sprite13,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
		break;
		case E_VINE:
			ML_bmp_8_and_cl(sprite14,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
		break;
		case E_TREE:
			for(int a = 0;a<5;a++)
			{
				ML_bmp_8_and_cl(sprite15,-(cameraX)+x+64-a*8,-(cameraY)+y+24);
				ML_bmp_8_and_cl(sprite18,-(cameraX)+x+64-a*8,-(cameraY)+y+32);
			}
		break;
		case E_WIN:
			ML_bmp_8_and_cl(sprite17,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
		break;
		case E_PRESS://TODO
			if(! activated)
			{
				ML_bmp_8_and_cl(sprite12,-(cameraX)+x+64,-(cameraY)+y+24);//TODO : laser
				ML_bmp_8_and_cl(sprite10,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
				if(distSquare < 7){
					ML_rectangle(33,0,100,7,0,ML_BLACK,ML_BLACK);
					PrintStr(34,1,"x2 : activate");
				}
			}
			else
			{
				ML_bmp_8_and_cl(sprite20,-(cameraX)+x+64,-(cameraY)+y+24);//TODO : laser
				ML_bmp_8_and_cl(sprite23,-(cameraX)+x+64,-(cameraY)+y+32);//TODO : laser
			}
		break;
		case E_ENEMY://TODO
			if(!frozen)
				ML_bmp_8_and_cl(sprite3,-(cameraX)+x+64,-(cameraY)+round(y)+32);//TODO : laser
			else
				ML_bmp_8_and_cl(sprite7,-(cameraX)+x+64,-(cameraY)+round(y)+32);//TODO : laser

		break;

		case E_BOMB :

			if(frameCount<150)
				ML_rectangle(-(cameraX)+x+64,-(cameraY)+round(y)+32,-(cameraX)+x+64+8,-(cameraY)+round(y)+32+7,0,ML_BLACK,ML_BLACK);
			if(frameCount < 100)
				ML_bmp_8_and_cl(sprite8,-(cameraX)+x+64,-(cameraY)+round(y)+32);//TODO : laser
			else if(frameCount < 150)
				ML_bmp_8_and_cl(sprite9,-(cameraX)+x+64,-(cameraY)+round(y)+32);//TODO : laser


		break;
	}
}
