

#include "src/all.h"


Game::Game()
{
	cameraX = 0;
	cameraY = 0;
	state = S_GAME;
	map = Single::getMap();
	heros = Single::getHeros();
	elements = Single::getElements();
	dialog = Single::getDialog();
	store = new Store();
	death = new Death();
	frameSinceReset = 0;
	invertColor = false;
	for(int i = 0;i<15;i++)deathDone[i] = 0;
	//startDialog(2);
}


int Game::getTotalMoney()
{
	//return 1000;
	int a = 0;
	for(int i = 0;i<11;i++)if(deathDone[i])a++;

	return a*100;
}


void Game::frame()
{
	frameSinceReset++;
	frameSinceStart++;

	if(state == S_GAME || state == S_DEATH || state == S_WIN)
	{
		if(state == S_GAME)heros->input();
		heros->frame();

		for(int i = 0;i<MAX_ELEMENT;i++)
		{
			elements[i].frame(0);
			if(elements[i].shouldDelete())
			{
				elements[i].start(0,0,-1);
			}
		}
		if(state == S_DEATH || state == S_WIN)death->frame();
	}
	if(state == S_DIALOG)
	{
		dialog->frame();
	}
	if(state == S_STORE)
	{
		store->frame();
	}


	Single::getFX()->frame();
	if(IsKeyDown(KEY_CTRL_F2))invertColor = !invertColor;

	if(frameSinceStart == 30)startDialog(2);
}

void Game::draw()
{


	if(state != S_DEATH)
	{
		cameraX = heros->getX()+4;
		cameraY = heros->getY()+4;
	}
	ML_rectangle(0,0,128,64,0,ML_BLACK,ML_BLACK);
	map->draw(cameraX,cameraY);

	int i;
	for(i = 0;i<MAX_ELEMENT;i++)
		elements[i].draw(cameraX,cameraY);

	heros->draw(cameraX,cameraY);

	//if(state == S_DEATH || state == S_WIN)death->draw();

	if(state == S_DIALOG)
	{
		dialog->draw();
	}
	if(state == S_STORE)
	{
		store->draw();
	}

	Single::getFX()->draw(cameraX,cameraY);
	if(state == S_DEATH || state == S_WIN)
	{
		death->draw();
	}

	//ML_rectangle(0,0,128,64,0,ML_WHITE,ML_CHECKER);
	int f = frameSinceReset*2;
	if(f<64)
	{
		ML_rectangle(-f,-32-f,128+f,96+f,64,ML_BLACK,ML_TRANSPARENT);
		ML_rectangle(63-f,31-f,64+f,32+f,2,ML_WHITE,ML_TRANSPARENT);
	}

	if(invertColor)
	{
		ML_rectangle(0,0,128,64,0,ML_XOR,ML_XOR);
	}

		//if(IsKeyDown(KEY_CTRL_EXIT))
		/*{
			Single::getElements();
			int a;
			for( a = 0;elements[a] != 0;a++);
			for( a = 0;elements[a] != 0;a++);
			for( a = 0;elements[a] != 0;a++);
			PrintV(1,1,a);

		}*/


}


void Game::finishDialog(int which)
{
	state = S_GAME;
	if(which == 0)die(D_BOREDOM);
}

void Game::die(int which)
{
	if(state != S_DEATH)
	{
		state = S_DEATH;
		death->init(which, ! deathDone[which] && which != D_RESET);
		deathDone[which] = 1;
		if(which == D_LASER || which == D_EXPLOSION || which == D_FALLING)
		{
			for(int i = 0;i<20;i++)
			{
				Single::getFX()->addParticle(Single::getHeros()->getX()+4,Single::getHeros()->getY()+4,((float)((rand()%20)-10)/5),((float)(rand()%20)-10)/5+Single::getHeros()->getSpeedY()/4,P_DEATH);
			}
		}
	}
}


void Game::win()
{
	if(state != S_WIN)
	{
		state = S_WIN;
		death->init(D_WIN,true);
	}
}


void Game::endDying()
{
	state = S_GAME;
	heros->reset();
	map->reset();
	Single::getFX()->reset();
	death->reset();
	dialog->reset();
	frameSinceReset = 0;
}

int Game::getDeath()
{
	return death->getDeath();
}

int Game::isDead()
{
	return state == S_DEATH;
}
void Game::startDialog(int which)
{
	if(which == 0)
	{
		state = S_STORE;
		store->open();
	}
	else
	{
		state = S_DIALOG;
		dialog->start(which-1);
	}
}
