#include "src/all.h"

Heros::Heros()
{

	//x and y position are the top left of the character !
	reset();
}


void Heros::reset()
{
	x = 64;
	y = 32;
	for(int i = 0;i<45;i++)
	{
		oldY[i] = y;
		oldX[i] = x;
	}
	pointerOld = 0;
	speedY = 0;
	isGrounded = 0;
	jumpAnim = 0;
	firingFreezeRay = 0;
	landingAnim = 0;

	for(int i = 0;i<7;i++)
	{
		upgrades[i] = 0;
	}
	//upgrades[U_BOMBS] = 1;
	frameUnderWater = 0;
	shiftPressed = false;
	canDoubleJump = true;
	bombCD = 0;
}
int Heros::hasUpgrade(int which)
{
	if(which<0 || which>6)return 0;
	return upgrades[which];
}
void Heros::addUpgrade(int which)
{
	if(which<0 || which>6)return;
	upgrades[which] = 1;
}
void Heros::draw(int cameraX,int cameraY)
{
	oldY[pointerOld] = y;
	oldX[pointerOld] = x;
	pointerOld=(pointerOld+1)%45;

	const unsigned char sprites0[]={0x0, 0x7e, 0x56, 0x56, 0x7e, 0x46, 0x7e, 0x0, };
	const unsigned char sprites1[]={0xff, 0xff, 0xc3, 0xdb, 0xdb, 0xc3, 0xff, 0xff, };
	const unsigned char sprites2[]={0xff, 0xff, 0xff, 0xe7, 0xe7, 0xff, 0xff, 0xff, };
	const unsigned char sprites3[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char sprites4[]={0xff, 0x0, 0x56, 0x56, 0x7e, 0x46, 0x7e, 0x0, };
	const unsigned char sprites5[]={0xff, 0xff, 0x0, 0x56, 0x56, 0x7e, 0x46, 0x0, };
	const unsigned char sprites6[]={0xff, 0x0, 0x56, 0x56, 0x7e, 0x46, 0x7e, 0x0, };
	const unsigned char sprites7[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char sprites8[]={0x0, 0x56, 0x6e, 0x56, 0x7e, 0x46, 0x7e, 0x0, };
	const unsigned char sprites9[]={0x1, 0x7d, 0x55, 0x55, 0x7d, 0x45, 0x7d, 0x1, };
	const unsigned char sprites10[]={0x81, 0xbd, 0x95, 0x95, 0xbd, 0x85, 0xbd, 0x81, };
	const unsigned char sprites11[]={0x1, 0x7d, 0x55, 0x55, 0x7d, 0x45, 0x7d, 0x1, };
	const unsigned char sprites12[]={0xff, 0xff, 0xff, 0xff, 0x0, 0x0, 0xff, 0xff, };
	const unsigned char sprites13[]={0x0, 0x7e, 0x56, 0x56, 0xe, 0x6, 0x7e, 0x0, };
	const unsigned char sprites14[]={0x0, 0x7e, 0x5a, 0x7e, 0x5a, 0x66, 0x7e, 0x0, };
	const unsigned char sprites15[]={0x0, 0x7e, 0x5a, 0x7e, 0x66, 0x5a, 0x7e, 0x0, };
	const unsigned char sprites16[]={0x0, 0x7e, 0x6a, 0x6a, 0x7e, 0x62, 0x5c, 0x0, };
	const unsigned char sprites17[]={0xec, 0x12, 0x6a, 0x6a, 0x7e, 0x62, 0x5c, 0x0, };
	const unsigned char sprites18[]={0xff, 0xcf, 0x80, 0x6a, 0x7e, 0x62, 0x5c, 0x0, };
	const unsigned char sprites19[]={0xff, 0xff, 0x3, 0x28, 0x7e, 0x62, 0x5c, 0x0, };
	const unsigned char sprites20[]={0xff, 0xff, 0xff, 0xd3, 0x0, 0x62, 0x5c, 0x0, };
	const unsigned char sprites21[]={0xff, 0xff, 0xff, 0xff, 0x63, 0x0, 0x5c, 0x0, };
	const unsigned char sprites22[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0x1, 0x0, };
	const unsigned char sprites23[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdc, 0x0,	};
	const unsigned char sprites24[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	};

	int shouldDisplay = true;

	int d = Single::getGame()->getDeath();

	if(Single::getGame()->isDead())
	{
		if(d == D_LASER || d == D_EXPLOSION || d == D_FALLING || d == D_PRESS )shouldDisplay = false;
	}


	if(shouldDisplay)
	{

	ML_bmp_8_and_cl(sprites2,oldX[(pointerOld+25)%45]-cameraX+64,oldY[(pointerOld+25)%45]-cameraY+32);

	ML_rectangle(oldX[(pointerOld+35)%45]-cameraX+64+2,oldY[(pointerOld+35)%45]-cameraY+32+2,oldX[(pointerOld+35)%45]-cameraX+64+5,oldY[(pointerOld+35)%45]-cameraY+32+5,0,ML_BLACK,ML_BLACK);
	ML_bmp_8_and_cl(sprites1,oldX[(pointerOld+35)%45]-cameraX+64,oldY[(pointerOld+35)%45]-cameraY+32);


	unsigned char toDisplay[8];
	const unsigned char* target;
	target = sprites0;
	if(landingAnim>0 && landingAnim < 3)target = sprites4;
	if(landingAnim>=3 && landingAnim < 6)target = sprites5;
	if(landingAnim>=6 && landingAnim < 9)target = sprites6;

//	if(jumpAnim>0 && jumpAnim < 3)target = sprites9;
	if(jumpAnim>=2 && jumpAnim < 7)target = sprites10;
//	if(jumpAnim>=6 && jumpAnim < 9)target = sprites11;

	int m = Single::getDialog()->melting();
	if(m>=0)
	{
		if(m == 0 || m == 1 || m == 2)target = sprites16;
		if(m == 3 || m == 4 || m == 5)target = sprites17;
		if(m == 6 || m == 7)target = sprites18;
		if(m == 8 || m == 9)target = sprites19;
		if(m == 10 || m == 11)target = sprites20;
		if(m == 12 || m == 13)target = sprites21;
		if(m == 14 || m == 15)target = sprites22;
		if(m == 16)target = sprites23;
		if(m > 16)target = sprites24;
	}
	//shouldDisplay= 1;
	if(Single::getGame()->isDead())
	{
		target = sprites8;
		if(Single::getGame()->getDeath() == D_BOREDOM)shouldDisplay = 0;
	}

	if(shouldDisplay)
	{
		for(int i = 0;i<8;i++)
		{
			toDisplay[i] = target[i];
			if(! goingLeft)
				toDisplay[i] = reverseBits(toDisplay[i]);
			if(m>=0)
				toDisplay[i] = reverseBits(toDisplay[i]);
		}

		if(m==-1)
			ML_rectangle(x-cameraX+64,y-cameraY+32,x-cameraX+64+7,y-cameraY+32+7,0,ML_BLACK,ML_BLACK);
		else ML_rectangle(x-cameraX+64,y-cameraY+32+m/2.5,x-cameraX+64+7,y-cameraY+32+7,0,ML_BLACK,ML_BLACK);



			ML_bmp_8_and_cl(toDisplay,x-cameraX+64,y-cameraY+32);

		if(firingFreezeRay)
		{
			if(goingLeft)
				ML_rectangle(x-cameraX+64+3,y-cameraY+32+4,x-cameraX+64-24,y-cameraY+32+6,0,ML_WHITE,ML_WHITE);
			else
				ML_rectangle(x-cameraX+64+4,y-cameraY+32+4,x-cameraX+64+32,y-cameraY+32+6,0,ML_WHITE,ML_WHITE);
		}

		if(upgrades[U_TORCH])
		{
			int tX = x-cameraX+64 + (goingLeft?-6:9);
			ML_rectangle(tX,y-cameraY+32+2,tX+4,y-cameraY+32+4,0,ML_WHITE,ML_WHITE);
			ML_rectangle(tX+1,y-cameraY+32+1,tX+3,y-cameraY+32+5,0,ML_WHITE,ML_WHITE);

		}
	}
	}
}


int Heros::pointInRay(int pointX, int pointY)
{
	if(!firingFreezeRay)return false;

	if(goingLeft)
		return pointX<=x+4 && pointX>=x-24 && pointY>=y-4 && pointY<=y+16;
	else
		return pointX>=x+4 && pointX<=x+32 && pointY>=y-4 && pointY<=y+16;
}


void Heros::setX(int newX)
{
	x = newX;
}
void Heros::setY(int newY)
{
	y = newY;
}
int Heros::getX()
{
	return x;
}

int Heros::getY()
{
	return (int)y;
}

float Heros::getSpeedY()
{
	return (int)speedY;
}



void Heros::input()
{
	if(IsKeyDown(KEY_CTRL_LEFT))
	{
		goingLeft = true;
		int flag = 1;
		for(int i = 0;i<7;i++)
			if(Single::getMap()->isSolid(x-1,y+i))flag = 0;
		if(flag)
			x--;
	}
	if(IsKeyDown(KEY_CTRL_F1))Single::getGame()->die(D_RESET);
	if(IsKeyDown(KEY_CTRL_RIGHT))
	{
		goingLeft = false;
		int flag = 1;
		for(int i = 0;i<7;i++)
			if(Single::getMap()->isSolid(x+8,y+i))flag = 0;
		if(flag)
			x++;
	}


	if(IsKeyDown(KEY_CTRL_ALPHA) && upgrades[U_BOMBS] && bombCD <0)
	{
		bombCD = 200;

		Element* elements = Single::getElements();
		int i;
		for(i = 0;elements[i].isAvailable() && i<MAX_ELEMENT;i++);
		elements[i].start(x+(goingLeft?-6:6),y,E_BOMB);
	}


	if(IsKeyDown(KEY_CTRL_OPTN) && upgrades[U_RAY])
	{
		firingFreezeRay = 1;
	}

	if(isGrounded && speedY<=0.5)//the speed check is for coyote time, google it if you want to know more
	{
		if(IsKeyDown(KEY_CTRL_SHIFT))
		{
			jumpAnim = 1;
			canDoubleJump = true;
			isGrounded = false;
			shiftPressed = true;
			speedY-=3;
			if(upgrades[U_BOOTS])speedY-=1;
		}
	}

	if(upgrades[U_WINGS] && !isGrounded)
	{
		if( ! IsKeyDown(KEY_CTRL_SHIFT))
		{
			shiftPressed = false;
		}
		if(IsKeyDown(KEY_CTRL_SHIFT) && !shiftPressed && canDoubleJump && speedY>-0.5)
		{
			speedY=-3;
			canDoubleJump = false;
		}

	}
}

void Heros::frame()
{
	if(landingAnim)landingAnim++;
	if(jumpAnim)jumpAnim++;
	if(firingFreezeRay)firingFreezeRay++;
	if(firingFreezeRay>60)firingFreezeRay = 0;
	bombCD--;




	speedY+=0.2;
	if(upgrades[U_LINGOT])
		speedY+=0.05;

	if(upgrades[U_TORCH] && ! Single::getGame()->isDead())
		if((rand()%1000)<=20)
		{
			Single::getFX()->addParticle(x+(goingLeft?-5:11),y+3,0,-0.02,P_BURNING);
		}


	if(Single::getMap()->isWater(x+4,y+4))
	{
		if(upgrades[U_TORCH])upgrades[U_TORCH] = 0;
		frameUnderWater++;
		if(speedY>0)
			isGrounded = true;
		speedY*=0.95;

		/* complicated AI to create water physics */
		if(speedY>2.5)speedY=2.5;
		if(speedY>2)speedY-=0.4;
		if(speedY>1.5)speedY-=0.4;
		if(speedY>1)speedY-=0.4;
		if(speedY>0.5)speedY-=0.3;
		if(speedY>0)speedY-=0.2;
	}
	else frameUnderWater = 0;

	if(frameUnderWater>40 + upgrades[U_BOTTLES]*400)
	{
		Single::getGame()->die(D_DROWNING);

	}

	if(speedY>0)
	{
		for(int i = 0;i<speedY;i++)
		{
			int flag = 1;
			for(int i = 0;i<8;i++)
				if(Single::getMap()->isSolid(x+i,y+8))flag = 0;
			if(flag)
				y++;
			else
			{
				if(speedY > 0.5)
					landingAnim = 1;

				if(speedY>=7)
					Single::getGame()->die(D_FALLING);
				speedY = 0;
				isGrounded = true;
				canDoubleJump = true;


			}
		}
	}
	else if(speedY<0)
	{
		for(int i = 0;i>speedY;i--)
		{
			int flag = 1;
			for(int i = 0;i<8;i++)
				if(Single::getMap()->isSolid(x+i,y-1))flag = 0;
			if(flag)
				y--;
			else
				speedY = 0;
		}
	}
	//y += speedY-((int)speedY);
}
