#include "src/all.h"


void Store::open()
{
	cursor = 0;
	refreshRemaining();
	keyDown = true;
}

void Store::refreshRemaining()
{
	int prices[8] = {100,100,200,300,100,500,100,-1};
	money = Single::getGame()->getTotalMoney();
	for(int i = 0;i<7;i++)
	{
		if(Single::getHeros()->hasUpgrade(i))
		{
			money -= prices[i];
		}
	}
}

void Store::frame()
{
	int prices[8] = {100,100,200,300,100,500,100,-1};

	if(IsKeyDown(KEY_CTRL_DOWN))
	{
		if(!keyDown)cursor++;
		keyDown = true;
	}
	else if(IsKeyDown(KEY_CTRL_UP))
	{
		if(!keyDown)cursor--;
		keyDown = true;

	}
	else
	{
		keyDown = false;
	}

	if(IsKeyDown(KEY_CTRL_EXE))
	{
		if(cursor == 7)
		{
			Single::getGame()->finishDialog(-1);
		}
		else
		{
			refreshRemaining();
			if( ! Single::getHeros()->hasUpgrade(cursor))
			{
				if(prices[cursor]<=money)
				{
					Single::getHeros()->addUpgrade(cursor);
					refreshRemaining();
				}
			}
		}
	}
	cursor = (cursor+8)%8;
}

void Store::printDescription(char* str, int startX, int y , int breakX)
{
	int x = startX;
	for(int i = 0;;i++)
	{
		if(str[i]!=' ')PrintCharXY(x,y,str[i]);
		x+=4;
		if(str[i]==' ' && x>breakX)
		{
			y+=6;
			x= startX;
		}
		if(str[i+1] == 0)break;
	}
}

void Store::draw()
{
	ML_rectangle(0,0,127,63,2,ML_WHITE,ML_BLACK);
	ML_rectangle(0,0,58,63,2,ML_WHITE,ML_BLACK);

	int prices[8] = {100,100,200,300,100,500,100,-1};

	char* items[8] = {
		"iron lingot","spring boots","wings","air bottles","freeze ray","bombs","torch","leave"
	};
	char* description[8] = {
        "A wonderful iron lingot ! It's not very useful, except being extremly heavy",
        "Jump much higher with these boots ! Very useful, especially on things that have no feet",
        "Beatiful hidden wings that allow you to jump one more time while in the air !",
        "Two air bottles that let you explore the  ocean for much longer than you could before",
        "Freeze your  ennemies until they transform into plateforms with this state of the art ray",
        "Explode once used. Not much more to say. Can be used  multiple times.",
        "Burn tree and vines, making elves cry. Goes out in the water",
        "Leave the store. Press EXE to validate or buy items"
    };

		for(int i = 0;i<8;i++)
		{
			PrintStr(8,i*7+5,items[i]);
			if(Single::getHeros()->hasUpgrade(i))
				PrintStr(3,i*7+5,"x");

		}
		PrintStr(3,cursor*7+5,"-");

		PrintStr(61,56,"cost :");
		if(prices[cursor] == -1)
		{
			PrintStr(61,38,"At your next new");
			PrintStr(61,44,"death, you will");
			PrintStr(61,50,"have     $");
			PrintV(81,50,Single::getGame()->getTotalMoney()+100);

			PrintStr(87,56,"free !");
		}
		else
		{


			if(Single::getHeros()->hasUpgrade(cursor))
				PrintStr(61,44,"Item owned");
			PrintStr(61,50,"remaining:     $");
			PrintV(104,50,money);
			PrintV(87,56,prices[cursor]);
			PrintStr(100,56,"$");
		}
		printDescription(description[cursor],61,4,110);
}
