#include "usefull.h"

#define SCA 0xD201D002
#define SCB 0x422B0009
#define SCE 0x80010070

typedef int(*sc_i2cp2sip) (char*, char*, short int*, short int*);
typedef int(*sc_iv) (void);
typedef int(*sc_4i) (int, int, int);

const unsigned int sc003b[] = {SCA, SCB, SCE, 0x3B};
const unsigned int sc0248[] = {SCA, SCB, SCE, 0x248};

#define RTC_GetTicks (*(sc_iv)sc003b)
#define PutKey (*(sc_4i)sc0248)
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)


int time_getTicks()
{
	return RTC_GetTicks();
}

int round(float a)
{
	float b = abs(a);
	int c;
	if((b-((int)b))<0.5)c = (int)b;
	else c=(int)b + 1;
	if(a<0)return -c;
	return c;
}

unsigned char reverseBits(unsigned char num)
{
    unsigned char count = sizeof(num) * 8 - 1;
    unsigned char reverse_num = num;

    num >>= 1;
    while(num)
    {
       reverse_num <<= 1;
       reverse_num |= num & 1;
       num >>= 1;
       count--;
    }
    reverse_num <<= count;
    return reverse_num;
}

int getFps()
{
static unsigned int fps = 0, fps_count = 0, time = 0;

if( time_getTicks() - time >= 128)
		{
			fps = fps_count;
			fps_count = 1;
			time = time_getTicks();
		} else fps_count++;

return fps;
}

int abs(int nombre)
{
return (nombre<0)?-nombre:nombre;
}

void key_inject(int keycode)
{
	PutKey(-1, -1, keycode);
}



void PrintV(int X,int Y , int  variable)
{

    int i, length=0;
    char str[12] = "0";
    if(variable)
    {
        if(variable<0)
        {
            length++;
            str[0] = '-';
            variable = -variable;
        }
        for(i=variable ; i ; i/=10) length++;
        str[length] = 0;
        for( ; variable ; variable/=10) str[--length] = variable%10+'0';
    }
    PrintStr(X,Y,str);
}

void setFps(int fpsWish)
{
static unsigned int fps = 0, fps_count = 0;

do
{
Sleep(1);
fps = time_getTicks();
}
while(fps < fps_count+fpsWish);
fps_count = time_getTicks();

}


int max(int a,int b)
{
if(a < b)return b;
return a;
}
